
//  A quem interessar possa :   

//  DWORD, LPVOID, HANDLE ...  so Windows Data Types    

//  DWORD - 32-bit unsigned integer. The range is 0 through 4294967295 decimal.
//  This type is declared in WinDef.h as follows: 
//  typedef unsigned long DWORD;

//  LPVOID - Pointer to any type. 
//  This type is declared in WinDef.h as follows:
//  typedef void *LPVOID;

//  HANDLE - Handle to an object. 
//  This type is declared in WinNT.h as follows:
//  typedef PVOID HANDLE;

//  LPVOID - Pointer to any type. 
//  This type is declared in WinDef.h as follows:
//  typedef void *LPVOID;

#include <windows.h>
#include <stdio.h>

#define NumeroDeThreads 4     // Constante para o Nmero de Threads

HANDLE MeuMutex;              // Uma varivel Handle  um "ponteiro especial" ...

void AtivarThread ( );

int main ()
{
    HANDLE Vetor_De_Threads [ NumeroDeThreads ];  // Vetor que ser usado para manipular os Threads criados
    DWORD  Identificador_Da_Thread;               // DWORD : 32-bit unsigned integer. The range is 0 through 4294967295 decimal.

    int i;

    // Cria um mutex (sem dono)
    MeuMutex = CreateMutex  (
                               NULL,              // parmetro relacionado a segurana do mutex
                               FALSE,             // parmetro que indica a ausncia de dono
                               NULL               // parmetro que d um nome ao mutex
                            );             

    if ( MeuMutex == NULL )
    {
        printf( " Erro na funcao CreateMutex: %d \n ", GetLastError() );
        return 0;
    }

    // Criao das Threads

    for ( i = 0; i < NumeroDeThreads; i++ )
    {
        Vetor_De_Threads [ i ] = CreateThread
                                  (
                                        NULL,                          // parmetro relacionado a segurana da thread
                                        0,                             // stack size padro
                                        (LPTHREAD_START_ROUTINE) AtivarThread,
                                        NULL,                          // argumentos da funo executada
                                        0,                             // criao de flags
                                        &Identificador_Da_Thread       // ID do thread
                                  );       

        if ( Vetor_De_Threads [ i ] == NULL )
        {
            printf ( " Erro na funcao CreateThread: %d \n ", GetLastError() );
            return 0;
        }
    }
   
    // Threads criadas e rodando 
    // espera os threads

    WaitForMultipleObjects ( NumeroDeThreads , Vetor_De_Threads, TRUE, INFINITE );

    // Destroi as variveis

    for ( i = 0; i < NumeroDeThreads; i++ )
    {
        CloseHandle( Vetor_De_Threads [ i ] );
    }

    CloseHandle ( MeuMutex ) ;
    
    printf ( "\n" );
    
    system ( "PAUSE" );
    
    return 0;
    
}

void AtivarThread ( )
{
    int Ciclos = 0;
    int EstadoAtual;

    // Requisita a posse do mutex.

    while ( Ciclos < 5 )
    {
        
        // Waits until the specified object is in the signaled state or the time-out interval elapses.   
        EstadoAtual = WaitForSingleObject     
                                         (   
                                               MeuMutex,    // handle para o mutex
                                               INFINITE    // sem time-out
                                          );                 

        switch ( EstadoAtual )
        {
            // caso a thread se aposse do mutex
            case WAIT_OBJECT_0:
            {
                DWORD identificador = 0;    
                
                identificador = GetCurrentThreadId();    // Retrieves the thread identifier of the calling thread.
                
                printf ( "A Thread %d esta trabalhando \n", identificador );
                Ciclos++;             
            }
            break;
          
            // caso o thread se aposse de um mutex abandonado
            case WAIT_ABANDONED:
            {
                printf( " \n A thread %d pegou um mutex abandonado \n ", GetCurrentThreadId() );
                Ciclos++;
            }    
            
        }
    }
}

