#include "stdafx.h"
#include <stdlib.h>
#include <stdio.h>

#using <System.dll>

using namespace System;
using namespace System::Threading;

public ref class Exemplo
{
private:
   // Criao do semforo.
   //
   static Semaphore^ Semaforo;

   // Intervalo de tempo para sincronizar o programa.
   static int intervalo;

public:
   static void Main()
   {
	   
      // Cria um semforo que atende at 3 pedidos concorrentes.
      // Seu estado inicial  zero, ou seja, est bloqueando
      // qualquer thread que venha a ser executado

      Semaforo = gcnew Semaphore( 0,3 );

      // Cria e inicia 5 threads.
      //
      for ( int i = 1; i <= 5; i++ )
      {
         Thread^ t = gcnew Thread(
         gcnew ParameterizedThreadStart( Trabalhador ) );

         // Inicia o thread usando o valor atribudo a ele.
         //
         t->Start( i );
      }

      // Espera meio segundo para que de tempo de todos os
      // threads se iniciarem e pararem no semforo.
      //
      Thread::Sleep( 500 );

      // Quando o mtodo Release() for chamado, haver a liberao
      // de um determinado nmero de vagas. Isso significa que
      // o semforo vai trocar o estado inicial 0, pelo estado indicado
      // pelo mtodo release(). No nosso exemplo esse estado pode ir
      // at trs.
      //
      Console::WriteLine( L"Main liberou 3 lugares." );
      Semaforo->Release( 3 );

      Console::WriteLine( L"O Main acabou." );
   }

private:
   static void Trabalhador( Object^ num )
   {
      // Cada Trabalhador comea encontrando o semforo.
      //
      Console::WriteLine( L"Thread {0} Foi iniciado e parou no semaforo.",        num );
      Semaforo->WaitOne();

      // Aqui  adicionado um intervalo de tempo que serve apenas para melhorar
      // a visualizao das sadas. Isso  feito de forma que cada thread espere
      // um pouco mais que o anterior.
      int Intervalo = Interlocked::Add( Intervalo, 100 );

      Console::WriteLine( L"Thread {0} Pegou um lugar.", num );
      // Apesar do nome Trabalhador, a nica tarefa atribuda ao thread
      //  dormir  =/ .
      //
      Thread::Sleep( 1000 + Intervalo );

      Console::WriteLine( L"Thread {0} liberou um lugar.", num );
      Semaforo->Release();
   }
};

int main()
{
        Exemplo ex;
	ex.Main();
	getchar();
	return(0);
}